Index: src/edu/ucsb/nceas/metacat/DocumentIdentifier.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentIdentifier.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/DocumentIdentifier.java	(revision 1217)
@@ -124,11 +124,12 @@
    */
   private String getNewestRev() throws SQLException, ClassNotFoundException
   {
-    PreparedStatement pstmt;
-    Connection conn = null;
+    PreparedStatement pstmt = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     
     try {
-      try {
+      /*try {
         //this connection is prone to error for some reason so we 
         //try to connect it three times before quiting.
         conn = util.openDBConnection();
@@ -144,9 +145,11 @@
                                sqleee.getMessage());
           }
         }
-      }
-      
-      pstmt = conn.prepareStatement("select rev from xml_documents where " +
+      }*/
+      dbConn=DBConnectionPool.
+                  getDBConnection("DocumentIdentifier.getNewestRev");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt = dbConn.prepareStatement("select rev from xml_documents where " +
                                     "docid like '" + docid + "'");
       pstmt.execute();
       ResultSet rs = pstmt.getResultSet();
@@ -154,19 +157,32 @@
       if (tablehasrows) {
         String retStr = rs.getString(1);
         pstmt.close();
-        conn.close();
+        //conn.close();
         return retStr;
       }
-      conn.close();
+      //conn.close();
     } catch(SQLException e) {
       System.out.println("error in DocumentIdentifier.getNewestRev(): " +
                           e.getMessage());
-      try {
-        conn.close();
-      } catch(SQLException e2) { throw e2; }
+      /*try {
+       conn.close();
+      } catch(SQLException e2) { throw e2; }*/
       throw e;
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn,serialNumber);
+      }//finally
+    }//finally
+        
     
+    
     return "1";
   }
   
Index: src/edu/ucsb/nceas/metacat/DBUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBUtil.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/DBUtil.java	(revision 1217)
@@ -51,7 +51,7 @@
  */
 public class DBUtil {
 
-  private Connection	conn = null;
+  //private Connection	conn = null;
 
   /**
    * main routine used for testing.
@@ -74,9 +74,9 @@
                     
           // Open a connection to the database
           MetaCatUtil   util = new MetaCatUtil();
-          Connection dbconn = util.openDBConnection();
+          //Connection dbconn = util.openDBConnection();
 
-          DBUtil dbutil = new DBUtil( dbconn );
+          DBUtil dbutil = new DBUtil();
           
           if ( args[0].equals("-dt") ) {
             String doctypes = dbutil.readDoctypes();
@@ -112,8 +112,8 @@
   /**
    * Construct an instance of the utility class
    */
-  public DBUtil( Connection conn ) {
-    this.conn = conn;
+  public DBUtil() {
+    //this.conn = conn;
   }
 
   /**
@@ -124,11 +124,16 @@
         throws SQLException  {
 
     Vector doctypeList = new Vector();
-
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
     try {
 
-      PreparedStatement pstmt =
-        conn.prepareStatement("SELECT public_id FROM xml_catalog " +
+      dbConn=DBConnectionPool.
+                  getDBConnection("DBUtil.readDoctypes");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt =
+        dbConn.prepareStatement("SELECT public_id FROM xml_catalog " +
                               "WHERE entry_type = 'DTD'");
 
       pstmt.execute();
@@ -144,6 +149,18 @@
     } catch (SQLException e) {
       throw new SQLException("DBUtil.readDoctypes(). " + e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
+       
 
     return formatToXML(doctypeList, "doctype");
   }
@@ -155,12 +172,17 @@
         throws SQLException, MalformedURLException, IOException
   {
     String systemID = null;
-    PreparedStatement pstmt;
+    PreparedStatement pstmt = null;
     StringBuffer cbuff = new StringBuffer();
-    
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     // get doctype's System ID from db catalog
     try {
-      pstmt = conn.prepareStatement("SELECT system_id " + 
+      
+      dbConn=DBConnectionPool.
+                  getDBConnection("DBUtil.readDTDSchema");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt = dbConn.prepareStatement("SELECT system_id " + 
                                     "FROM xml_catalog " +
                                     "WHERE entry_type in ('DTD','Schema') " +
                                     "AND public_id LIKE ?");
@@ -178,6 +200,17 @@
     } catch (SQLException e) {
       throw new SQLException("DBUtil.readDTD(). " + e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
 
     // read from URL stream as specified by the System ID.
     try {
@@ -220,12 +253,17 @@
 
     Vector dataguide = new Vector();
     String path;
-    PreparedStatement pstmt;
+    PreparedStatement pstmt = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     
     try {
-
+        dbConn=DBConnectionPool.
+                  getDBConnection("DBUtil.readDataGuide");
+        serialNumber=dbConn.getCheckOutSerialNumber();
+        
         if ( doctype != null ) {
-            pstmt = conn.prepareStatement("SELECT distinct path, nodeid " + 
+            pstmt = dbConn.prepareStatement("SELECT distinct path, nodeid " + 
                                           "FROM xml_index " +
                                           "WHERE path LIKE '/%' " + 
                                           "AND doctype LIKE ? " +
@@ -232,7 +270,8 @@
                                           "ORDER BY nodeid");
             pstmt.setString(1, doctype);
         } else {
-            pstmt = conn.prepareStatement("SELECT distinct path, doctype, nodeid " + 
+            pstmt = 
+            dbConn.prepareStatement("SELECT distinct path, doctype, nodeid " + 
                                           "FROM xml_index " +
                                           "WHERE path LIKE '/%' " + 
                                           "ORDER BY doctype, nodeid");
@@ -254,6 +293,17 @@
     } catch (SQLException e) {
       throw new SQLException("DBUtil.readDataGuide(). " + e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
 
     return formatToXML(dataguide);
   }
@@ -355,11 +405,15 @@
 
     String accnum = null;
     String sep = MetaCatUtil.getOption("accNumSeparator");
-
+    PreparedStatement pstmt = null;
+    DBConnection dbConn = null;
+    int serialNumber = -1;
     try {
-
-      PreparedStatement pstmt =
-        conn.prepareStatement(
+        dbConn=DBConnectionPool.
+                  getDBConnection("DBUtil.getMaxDocid");
+        serialNumber=dbConn.getCheckOutSerialNumber();
+        pstmt =
+        dbConn.prepareStatement(
             "SELECT docid, rev, acc FROM " +
             "( " +
             "SELECT docid, rev, acc FROM " +
@@ -402,6 +456,17 @@
     } catch (SQLException e) {
       throw new SQLException("DBUtil.getMaxDocid(). " + e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }//try
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
 
     return accnum;
   }
Index: src/edu/ucsb/nceas/metacat/DBSimpleQuery.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBSimpleQuery.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/DBSimpleQuery.java	(revision 1217)
@@ -45,7 +45,7 @@
  */
 public class DBSimpleQuery {
 
-  private Connection	conn = null;
+  //private Connection	conn = null;
 
   /**
    * the main routine used to test the DBSimpleQuery utility.
@@ -69,10 +69,10 @@
 
           // Open a connection to the database
           MetaCatUtil   util = new MetaCatUtil();
-          Connection dbconn = util.openDBConnection();
+          //Connection dbconn = util.openDBConnection();
 
           // Execute the simple query
-          DBSimpleQuery rd = new DBSimpleQuery(dbconn);
+          DBSimpleQuery rd = new DBSimpleQuery();
           Hashtable nodelist = null;
           if (doctype.equals("any") || doctype.equals("ANY")) {
             nodelist = rd.findDocuments(query);
@@ -115,12 +115,12 @@
    *
    * @param conn the JDBC connection that we use for the query
    */
-  public DBSimpleQuery( Connection conn ) 
+  public DBSimpleQuery() 
                   throws IOException, 
                          SQLException, 
                          ClassNotFoundException
   {
-    this.conn = conn;
+    //this.conn = conn;
   }
   
   /** 
@@ -141,7 +141,9 @@
   public Hashtable findDocuments(String query, String requestedDoctype) {
       Hashtable	 docListResult = new Hashtable();
 
-      PreparedStatement pstmt;
+      PreparedStatement pstmt = null;
+      DBConnection dbConn = null;
+      int serialNumber = -1;
 
       // Now look up the document id
       String docid = null;
@@ -151,10 +153,13 @@
       //StringBuffer document = null; 
 
       try {
+        dbConn=DBConnectionPool.
+                  getDBConnection("DBSimpleQuery.findDocuments");
+        serialNumber=dbConn.getCheckOutSerialNumber();
         if (requestedDoctype == null || 
             requestedDoctype.equals("any") || 
             requestedDoctype.equals("ANY")) {
-          pstmt = conn.prepareStatement(
+          pstmt = dbConn.prepareStatement(
                 "SELECT docid,docname,doctype,doctitle " +
                 "FROM xml_documents " +
                 "WHERE docid IN " +
@@ -164,7 +169,7 @@
                 // Bind the values to the query
                 pstmt.setString(1, query);
         } else {
-          pstmt = conn.prepareStatement(
+          pstmt = dbConn.prepareStatement(
                 "SELECT docid,docname,doctype,doctitle " +
                 "FROM xml_documents " +
                 "WHERE docid IN " +
@@ -210,6 +215,10 @@
         System.out.println("Error in DBSimpleQuery.findDocuments: " + 
                             e.getMessage());
       }
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }
 
     return docListResult;
   }
Index: src/edu/ucsb/nceas/metacat/ForceReplicationHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/ForceReplicationHandler.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/ForceReplicationHandler.java	(revision 1217)
@@ -48,7 +48,7 @@
 public class ForceReplicationHandler implements Runnable
 {
   private Thread btThread;
-  private Connection conn;
+  //private Connection conn;
   private MetaCatUtil util = new MetaCatUtil();
   private String docid;
   private String action;
@@ -105,9 +105,9 @@
          return;
       }
       URL comeAndGetIt = null;
-      conn = util.getConnection();
+      //conn = util.getConnection();
       // If no server in xml_replication table, metacat don't need do anything
-      if (ReplicationHandler.buildServerList(conn)==null)
+      if (ReplicationHandler.buildServerList()==null)
       {
         return;
       }
@@ -177,7 +177,7 @@
         //the URL never directly replies to the request.  this simply
         //invoces a read request from the server to this local machine.
       }//while
-      util.returnConnection(conn);
+      //util.returnConnection(conn);
     }//try
     catch(Exception e)
     {
